# -*- coding: utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import sys
import array
import struct
import ui_ppremain
import ui_pprepokeedit
import ui_ppremapedit
import ui_ppretmhmedit
import ui_ppremoveedit
import ui_ppreitemedit
import ui_ppreabilityedit
import ui_pprescripts
import texttopoke
import narc
import execute
import poketext
import scripts

class MainWindow(QMainWindow, ui_ppremain.Ui_MainWindow):
    def __init__(self,parent=None):
        super(MainWindow,self).__init__(parent)
        self.setupUi(self)
        self.updateUi()
        self.romname=""
        #print scripts.cmd
        #self.Of =(map table offset,invalid script begin, invalid script end,pl tutmoves ofset, types)
        #self.TN=(type,ability,items,moves,pokenames,height,weight, description,flavor text,forms,
    def updateUi(self):
        self.nameLabel.text="ROM Name:"
    def writeROM(self):
        self.rom.create(unicode(self.outputNameEdit.text()))
    def openROM(self):
        self.rom=execute.NDSFILES(unicode(self.nameEdit.text()))
        self.rom.dump()
        self.ID=getROMID()
        self.lang = getLang()
        if self.ID == 0x4C50:
            self.romname="Platinum"
            if self.lang==0x4A:
                self.Of=(0xE56F0,501 ,1050 )
            elif self.lang==0x45:
                self.Of=(0xE601C,501, 1050 )
        elif self.ID== 0x50:
            self.romname="Pearl"
            if self.lang==0x4A:
                self.Of=(0xF0C28, )
            elif self.lang==0x45:
                self.Of=(0xEEDBC, )
            elif self.lang==0x44:
                self.Of=(0xEEDCC, )
            elif self.lang==0x46:
                self.Of=(0xEEDFC, )
            elif self.lang==0x49:
                self.Of=(0xEED70, )
            elif self.lang==0x53:
                self.Of=(0xEEE08, )
        elif self.ID==0x44:
            self.romname="Diamond"
            if self.lang==0x4A:
                self.Of=(0xF0C28, )
            elif self.lang==0x45:
                self.Of=(0xEEDBC, )
            elif self.lang==0x44:
                self.Of=(0xEEDCC, )
            elif self.lang==0x46:
                self.Of=(0xEEDFC, )
            elif self.lang==0x49:
                self.Of=(0xEED70, )
            elif self.lang==0x53:
                self.Of=(0xEEE08, )

    def openPokeEdit(self):
        p=PokeEditDlg(self)
        p.exec_()
    def openMapEdit(self):
        p=MapDlg(self)
        p.exec_()
    def openTmHmEdit(self):
        p=TmHmDlg(self)
        p.exec_()
    def openMoveEdit(self):
        p=MoveDlg(self)
        p.exec_()
    def openItemEdit(self):
        p=ItemDlg(self)
        p.exec_()
    def openAbilityEdit(self):
        p=AbilityDlg(self)
        p.exec_()
    def openScriptEdit(self):
        p=ScriptDlg(self)
        p.exec_()
def getROMID():
	filename = mw.rom.getFolder()+"/header.bin"
	fh=QFile(filename)
	fh.open(QIODevice.ReadOnly)
	ds=QDataStream(fh)
	ds.setByteOrder(QDataStream.LittleEndian)
	fh.seek(8)
	id=ds.readUInt16()
	fh.close()
	return id
def getLang():
    filename = mw.rom.getFolder()+"/header.bin"
    fh=QFile(filename)
    fh.open(QIODevice.ReadOnly)
    ds=QDataStream(fh)
    ds.setByteOrder(QDataStream.LittleEndian)
    fh.seek(15)
    id=ds.readUInt16()&0xFF
    fh.close()
    return id
def ReadMsgNarc():
	if mw.ID== 0x4C50:
		filename = mw.rom.getFolder()+"/root/msgdata/pl_msg.narc"
	else:
		filename = mw.rom.getFolder()+"/root/msgdata/msg.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)
def ReadPersonalNarc():
	if mw.ID== 0x4c50:
		filename = mw.rom.getFolder()+"/root/poketool/personal/pl_personal.narc"
	elif mw.ID == 0x44:
		filename = mw.rom.getFolder()+"/root/poketool/personal/personal.narc"
	else:
		filename = mw.rom.getFolder()+"/root/poketool/personal_pearl/personal.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)	
def ReadWOTblNarc():
	#if mw.ID==0x4C50:
	filename = mw.rom.getFolder()+"/root/poketool/personal/wotbl.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)
def ReadEvoNarc():
	#if mw.ID==0x4C50:
	filename = mw.rom.getFolder()+"/root/poketool/personal/evo.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)	
def ReadWazaNarc():
	if mw.ID==0x4C50:
		filename = mw.rom.getFolder()+"/root/poketool/waza/pl_waza_tbl.narc"
	else:
		filename = mw.rom.getFolder()+"/root/poketool/waza/waza_tbl.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)	
def ReadScriptNarc():
	if mw.ID==0x4C50:
		filename = mw.rom.getFolder()+"/root/fielddata/script/scr_seq.narc"
	else:
		filename = mw.rom.getFolder()+"/root/fielddata/script/scr_seq_release.narc"
	f = open(filename, "rb")
	d = f.read()
	f.close()
	return narc.NARC(d)
def WriteScriptNarc(archive):
    if mw.ID==0x4C50:
        filename = mw.rom.getFolder()+"/root/fielddata/script/scr_seq.narc"
    else:
        filename = mw.rom.getFolder()+"/root/fielddata/script/scr_seq_release.narc"
    f = open(filename, "wb")
    archive.ToFile(f)
    f.close()
class PokeEditDlg(QDialog, ui_pprepokeedit.Ui_PokeEditDlg):
    def __init__(self,parent=None):
        super(PokeEditDlg,self).__init__(parent)
        self.setupUi(self)
        self.personal=ReadPersonalNarc()
        self.archive = ReadMsgNarc()
        self.moves=ReadWOTblNarc()
        self.evos=ReadEvoNarc()
        self.temp=[]
        self.dataids=[]
        for i in range(0,82):
            self.temp.append(0)
        if mw.ID == 0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[616])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[624])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[555])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[557])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[565])
        binary.decrypt()
        self.type1.addItems(binary.strlist)
        self.type2.addItems(binary.strlist)
        if mw.ID == 0x4C50:
            binary=poketext.PokeTextData(self.archive.gmif.files[610])
        else:
            if mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[546])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[552])
        binary.decrypt()
        self.ability1.addItems(binary.strlist)
        self.ability2.addItems(binary.strlist)
        if mw.ID == 0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[390])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[392])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[341])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[342])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[344])
        binary.decrypt()
        self.heldItem1.addItems(binary.strlist)
        self.heldItem2.addItems(binary.strlist)
        self.evoItem1.addItems(binary.strlist)
        self.evoItem2.addItems(binary.strlist)
        self.evoItem3.addItems(binary.strlist)
        self.evoItem4.addItems(binary.strlist)
        self.evoItem5.addItems(binary.strlist)
        self.evoItem6.addItems(binary.strlist)
        self.evoItem7.addItems(binary.strlist)
        if mw.ID == 0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[636])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[647])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[575])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[577])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[588])
        binary.decrypt()
        self.move1.addItems(binary.strlist)
        self.move2.addItems(binary.strlist)
        self.move3.addItems(binary.strlist)
        self.move4.addItems(binary.strlist)
        self.move5.addItems(binary.strlist)
        self.move6.addItems(binary.strlist)
        self.move7.addItems(binary.strlist)
        self.move8.addItems(binary.strlist)
        self.move9.addItems(binary.strlist)
        self.move10.addItems(binary.strlist)
        self.move11.addItems(binary.strlist)
        self.move12.addItems(binary.strlist)
        self.move13.addItems(binary.strlist)
        self.move14.addItems(binary.strlist)
        self.move15.addItems(binary.strlist)
        self.move16.addItems(binary.strlist)
        self.move17.addItems(binary.strlist)
        self.move18.addItems(binary.strlist)
        self.move19.addItems(binary.strlist)
        self.move20.addItems(binary.strlist)
        self.evoAtk1.addItems(binary.strlist)
        self.evoAtk2.addItems(binary.strlist)
        self.evoAtk3.addItems(binary.strlist)
        self.evoAtk4.addItems(binary.strlist)
        self.evoAtk5.addItems(binary.strlist)
        self.evoAtk6.addItems(binary.strlist)
        self.evoAtk7.addItems(binary.strlist)
        if mw.ID == 0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[408])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[412])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[356])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[357])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[362])
        binary.decrypt()
        self.choosePokemon.addItems(binary.strlist)
        self.evoPkm1.addItems(binary.strlist)
        self.evoPkm2.addItems(binary.strlist)
        self.evoPkm3.addItems(binary.strlist)
        self.evoPkm4.addItems(binary.strlist)
        self.evoPkm5.addItems(binary.strlist)
        self.evoPkm6.addItems(binary.strlist)
        self.evoPkm7.addItems(binary.strlist)
        self.evoReqPkm1.addItems(binary.strlist)
        self.evoReqPkm2.addItems(binary.strlist)
        self.evoReqPkm3.addItems(binary.strlist)
        self.evoReqPkm4.addItems(binary.strlist)
        self.evoReqPkm5.addItems(binary.strlist)
        self.evoReqPkm6.addItems(binary.strlist)
        self.evoReqPkm7.addItems(binary.strlist)
        self.romname=self.romnameLabel.text()+mw.romname
        self.romnameLabel.setText(self.romname)
        self.tmlist=(self.tm1,self.tm2,self.tm3,self.tm4,self.tm5,self.tm6,self.tm7,self.tm8,self.tm9,self.tm10,self.tm11,self.tm12,self.tm13,self.tm14,self.tm15,self.tm16,self.tm17,self.tm18,self.tm19,self.tm20,self.tm21,self.tm22,self.tm23,self.tm24,self.tm25,self.tm26,self.tm27,self.tm28,self.tm29,self.tm30,self.tm31,self.tm32,self.tm33,self.tm34,self.tm35,self.tm36,self.tm37,self.tm38,self.tm39,self.tm40,self.tm41,self.tm42,self.tm43,self.tm44,self.tm45,self.tm46,self.tm47,self.tm48,self.tm49,self.tm50,self.tm51,self.tm52,self.tm53,self.tm54,self.tm55,self.tm56,self.tm57,self.tm58,self.tm59,self.tm60,self.tm61,self.tm62,self.tm63,self.tm64,self.tm65,self.tm66,self.tm67,self.tm68,self.tm69,self.tm70,self.tm71,self.tm72,self.tm73,self.tm74,self.tm75,self.tm76,self.tm77,self.tm78,self.tm79,self.tm80,self.tm81,self.tm82,self.tm83,self.tm84,self.tm85,self.tm86,self.tm87,self.tm88,self.tm89,self.tm90,self.tm91,self.tm92)
        self.hmlist=(self.hm1,self.hm2,self.hm3,self.hm4,self.hm5,self.hm6,self.hm7,self.hm8)
        self.movelist=(self.move1,self.move2,self.move3,self.move4,self.move5,self.move6,self.move7,self.move8,self.move9,self.move10,self.move11,self.move12,self.move13,self.move14,self.move15,self.move16,self.move17,self.move18,self.move19,self.move20)
        self.movelvllist=(self.moveLvl1,self.moveLvl2,self.moveLvl3,self.moveLvl4,self.moveLvl5,self.moveLvl6,self.moveLvl7,self.moveLvl8,self.moveLvl9,self.moveLvl10,self.moveLvl11,self.moveLvl12,self.moveLvl13,self.moveLvl14,self.moveLvl15,self.moveLvl16,self.moveLvl17,self.moveLvl18,self.moveLvl19,self.moveLvl20)
        self.evotypes=(self.evoType1,self.evoType2,self.evoType3,self.evoType4,self.evoType5,self.evoType6,self.evoType7)
        self.evopkms=(self.evoPkm1,self.evoPkm2,self.evoPkm3,self.evoPkm4,self.evoPkm5,self.evoPkm6,self.evoPkm7)
        #self.choosePokemon.setCurrentIndex(0)
        #self.updateUi()
        #self.extractToSql()
    def changedPokemon(self,event):
        self.pokeid=self.choosePokemon.currentIndex()
        self.pokeName.setText(self.choosePokemon.currentText())
        if self.pokeid < 494:
            if mw.ID == 0x4C50:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[696])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[709])
            else:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[606])
                elif mw.lang==0x4B:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[608])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[620])
            temptext.decrypt()
            self.height.setText(temptext.strlist[self.pokeid].replace("\\x01E2","").replace("\\x0001", ""))
            if mw.ID == 0x4C50:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[694])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[707])
            else:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[605])
                elif mw.lang==0x4B:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[607])
                else:
                    stemptext=poketext.PokeTextData(self.archive.gmif.files[619])
            temptext.decrypt()
            self.weight.setText(temptext.strlist[self.pokeid].replace("\\x01E2","").replace("\\x0001", ""))
            if mw.ID == 0x4C50:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[698])
                elif mw.lang==0x45:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[718])
                elif mw.lang==0x44:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[720])
                elif mw.lang==0x46:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[719])
                elif mw.lang==0x49:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[721])
                elif mw.lang==0x53:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[722])
            else:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[607])
                elif mw.lang==0x4B:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[609])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[621])
            temptext.decrypt()
            self.description.setText(temptext.strlist[self.pokeid])
            if mw.ID == 0x4C50:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[693])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[706])
            elif mw.ID==0x50:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[602])
                elif mw.lang==0x4B:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[604])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[616])
            else:
                if mw.lang==0x4A:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[601])
                elif mw.lang==0x4B:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[603])
                else:
                    temptext=poketext.PokeTextData(self.archive.gmif.files[615])
            temptext.decrypt()
            self.flavorText.setPlainText(temptext.strlist[self.pokeid])
        self.chooseForm.clear()
        if mw.ID == 0x4C50:
            if self.pokeid == 386:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[685])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[697])
                formtext.decrypt()
                self.dataids=[self.pokeid,496,497,498]
                self.chooseForm.addItem(formtext.strlist[111])
                self.chooseForm.addItem(formtext.strlist[112])
                self.chooseForm.addItem(formtext.strlist[113])
                self.chooseForm.addItem(formtext.strlist[114])
            elif self.pokeid == 413:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[685])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[697])
                formtext.decrypt()
                self.dataids=[self.pokeid,499,500]
                self.chooseForm.addItem(formtext.strlist[17])
                self.chooseForm.addItem(formtext.strlist[18])
                self.chooseForm.addItem(formtext.strlist[19])
            elif self.pokeid == 479:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[685])
                else: 
                    formtext=poketext.PokeTextData(self.archive.gmif.files[697])
                formtext.decrypt()
                self.dataids=[self.pokeid,503,504,505,506,507]
                self.chooseForm.addItem(formtext.strlist[119])
                self.chooseForm.addItem(formtext.strlist[120])
                self.chooseForm.addItem(formtext.strlist[121])
                self.chooseForm.addItem(formtext.strlist[122])
                self.chooseForm.addItem(formtext.strlist[123])
                self.chooseForm.addItem(formtext.strlist[124])
            elif self.pokeid == 487:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[685])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[697])
                formtext.decrypt()
                self.dataids=[self.pokeid,501]
                self.chooseForm.addItem(formtext.strlist[117])
                self.chooseForm.addItem(formtext.strlist[118])
            elif self.pokeid == 492:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[685])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[697])
                formtext.decrypt()
                self.dataids=[self.pokeid,502]
                self.chooseForm.addItem(formtext.strlist[115])
                self.chooseForm.addItem(formtext.strlist[116])
            else:
                self.dataids=[self.pokeid]
                self.chooseForm.addItem("")
        else:
            if self.pokeid == 386:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[600])
                elif mw.lang==0x4B:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[602])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[614])
                formtext.decrypt()
                self.dataids=[self.pokeid,496,497,498]
                self.chooseForm.addItem(formtext.strlist[110])
                self.chooseForm.addItem(formtext.strlist[111])
                self.chooseForm.addItem(formtext.strlist[112])
                self.chooseForm.addItem(formtext.strlist[113])
            elif self.pokeid == 413:
                if mw.lang==0x4A:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[600])
                elif mw.lang==0x4B:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[602])
                else:
                    formtext=poketext.PokeTextData(self.archive.gmif.files[614])
                formtext.decrypt()
                self.dataids=[self.pokeid,499,500]
                self.chooseForm.addItem(formtext.strlist[17])
                self.chooseForm.addItem(formtext.strlist[18])
                self.chooseForm.addItem(formtext.strlist[19])
            else:
                self.dataids=[self.pokeid]
                self.chooseForm.addItem("")
    def changedForm(self,event):
        file=self.personal.gmif.files[self.dataids[self.chooseForm.currentIndex()]]
        self.temp[0]=ord(file[0])
        self.temp[1]=ord(file[1])
        self.temp[2]=ord(file[2])
        self.temp[3]=ord(file[3])
        self.temp[4]=ord(file[4])
        self.temp[5]=ord(file[5])
        self.temp[6]=ord(file[6])
        self.temp[7]=ord(file[7])
        self.temp[8]=ord(file[8])
        self.temp[9]=ord(file[9])
        self.temp[10]=ord(file[10])&3
        self.temp[11]=(ord(file[10])&0xC)>>2
        self.temp[12]=(ord(file[10])&0x30)>>4
        self.temp[13]=(ord(file[10])&0xC0)>>6
        self.temp[14]=ord(file[11])&0x3
        self.temp[15]=(ord(file[11])&0xC)>>2
        self.temp[16]=ord(file[12])|(ord(file[13])<<8)
        self.temp[17]=ord(file[14])|(ord(file[15])<<8)
        self.temp[18]=ord(file[16])
        self.temp[19]=ord(file[17])
        self.temp[20]=ord(file[18])
        self.temp[21]=ord(file[19])
        self.temp[22]=ord(file[20])-1
        self.temp[23]=ord(file[21])-1
        self.temp[24]=ord(file[22])
        self.temp[25]=ord(file[23])
        self.temp[26]=ord(file[24])
        self.temp[27]=ord(file[25])
        self.temp[28]=ord(file[28])
        self.temp[29]=ord(file[29])
        self.temp[30]=ord(file[30])
        self.temp[31]=ord(file[31])
        self.temp[32]=ord(file[32])
        self.temp[33]=ord(file[33])
        self.temp[34]=ord(file[34])
        self.temp[35]=ord(file[35])
        self.temp[36]=ord(file[36])
        self.temp[37]=ord(file[37])
        self.temp[38]=ord(file[38])
        self.temp[39]=ord(file[39])
        self.temp[40]=ord(file[40])
        #Start Moveset
        self.reachedFFFF=False
        self.nummoves=0
        file=self.moves.gmif.files[self.dataids[self.chooseForm.currentIndex()]]
        if not self.reachedFFFF:
            temp1=ord(file[0])|(ord(file[1])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[41]=0
                self.nummoves=0
            else:
                self.temp[41]=temp1
        else:
            self.temp[41]=0
        if not self.reachedFFFF:
            temp1=ord(file[2])|(ord(file[3])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[42]=0
                self.nummoves=1
            else:
                self.temp[42]=temp1
        else:
            self.temp[42]=0
        if not self.reachedFFFF:
            temp1=ord(file[4])|(ord(file[5])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[43]=0
                self.nummoves=2
            else:
                self.temp[43]=temp1
        else:
            self.temp[43]=0
        if not self.reachedFFFF:
            temp1=ord(file[6])|(ord(file[7])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[44]=0
                self.nummoves=3
            else:
                self.temp[44]=temp1
        else:
            self.temp[44]=0
        if not self.reachedFFFF:
            temp1=ord(file[8])|(ord(file[9])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[45]=0
                self.nummoves=4
            else:
                self.temp[45]=temp1
        else:
            self.temp[45]=0
        if not self.reachedFFFF:
            temp1=ord(file[10])|(ord(file[11])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[46]=0
                self.nummoves=5
            else:
                self.temp[46]=temp1
        else:
            self.temp[46]=0
        if not self.reachedFFFF:
            temp1=ord(file[12])|(ord(file[13])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[47]=0
                self.nummoves=6
            else:
                self.temp[47]=temp1
        else:
            self.temp[47]=0
        if not self.reachedFFFF:
            temp1=ord(file[14])|(ord(file[15])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[48]=0
                self.nummoves=7
            else:
                self.temp[48]=temp1
        else:
            self.temp[48]=0
        if not self.reachedFFFF:
            temp1=ord(file[16])|(ord(file[17])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[49]=0
                self.nummoves=8
            else:
                self.temp[49]=temp1
        else:
            self.temp[49]=0
        if not self.reachedFFFF:
            temp1=ord(file[18])|(ord(file[19])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[50]=0
                self.nummoves=9
            else:
                self.temp[50]=temp1
        else:
            self.temp[50]=0
        if not self.reachedFFFF:
            temp1=ord(file[20])|(ord(file[21])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[51]=0
                self.nummoves=10
            else:
                self.temp[51]=temp1
        else:
            self.temp[51]=0
        if not self.reachedFFFF:
            temp1=ord(file[22])|(ord(file[23])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[52]=0
                self.nummoves=11
            else:
                self.temp[52]=temp1
        else:
            self.temp[52]=0
        if not self.reachedFFFF:
            temp1=ord(file[24])|(ord(file[25])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[53]=0
                self.nummoves=12
            else:
                self.temp[53]=temp1
        else:
            self.temp[53]=0
        if not self.reachedFFFF:
            temp1=ord(file[26])|(ord(file[27])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[54]=0
                self.nummoves=13
            else:
                self.temp[54]=temp1
        else:
            self.temp[54]=0
        if not self.reachedFFFF:
            temp1=ord(file[28])|(ord(file[29])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[55]=0
                self.nummoves=14
            else:
                self.temp[55]=temp1
        else:
            self.temp[55]=0
        if not self.reachedFFFF:
            temp1=ord(file[30])|(ord(file[31])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[56]=0
                self.nummoves=15
            else:
                self.temp[56]=temp1
        else:
            self.temp[56]=0
        if not self.reachedFFFF:
            temp1=ord(file[32])|(ord(file[33])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[57]=0
                self.nummoves=16
            else:
                self.temp[57]=temp1
        else:
            self.temp[57]=0
        if not self.reachedFFFF:
            temp1=ord(file[34])|(ord(file[35])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[58]=0
                self.nummoves=17
            else:
                self.temp[58]=temp1
        else:
            self.temp[58]=0
        if not self.reachedFFFF:
            temp1=ord(file[36])|(ord(file[37])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[59]=0
                self.nummoves=18
            else:
                self.temp[59]=temp1
        else:
            self.temp[59]=0
        if not self.reachedFFFF:
            temp1=ord(file[38])|(ord(file[39])<<8)
            if temp1==0xFFFF:
                self.reachedFFFF=True
                self.temp[60]=0
                self.nummoves=19
            else:
                self.temp[60]=temp1
                self.nummoves=20
        else:
            self.temp[60]=0
        #Start Evo	
        file=self.evos.gmif.files[self.dataids[self.chooseForm.currentIndex()]]
        self.temp[61]=ord(file[0])|(ord(file[1])<<8)
        self.temp[62]=ord(file[2])|(ord(file[3])<<8)
        self.temp[63]=ord(file[4])|(ord(file[5])<<8)
        self.temp[64]=ord(file[6])|(ord(file[7])<<8)
        self.temp[65]=ord(file[8])|(ord(file[9])<<8)
        self.temp[66]=ord(file[10])|(ord(file[11])<<8)
        self.temp[67]=ord(file[12])|(ord(file[13])<<8)
        self.temp[68]=ord(file[14])|(ord(file[15])<<8)
        self.temp[69]=ord(file[16])|(ord(file[17])<<8)
        self.temp[70]=ord(file[18])|(ord(file[19])<<8)
        self.temp[71]=ord(file[20])|(ord(file[21])<<8)
        self.temp[72]=ord(file[22])|(ord(file[23])<<8)
        self.temp[73]=ord(file[24])|(ord(file[25])<<8)
        self.temp[74]=ord(file[26])|(ord(file[27])<<8)
        self.temp[75]=ord(file[28])|(ord(file[29])<<8)
        self.temp[76]=ord(file[30])|(ord(file[31])<<8)
        self.temp[77]=ord(file[32])|(ord(file[33])<<8)
        self.temp[78]=ord(file[34])|(ord(file[35])<<8)
        self.temp[79]=ord(file[36])|(ord(file[37])<<8)
        self.temp[80]=ord(file[38])|(ord(file[39])<<8)
        self.temp[81]=ord(file[40])|(ord(file[41])<<8)
        self.evoparams=(self.temp[62],self.temp[65],self.temp[68],self.temp[71],self.temp[74],self.temp[77],self.temp[80])
        #UpdateUi
        self.updateUi()
    def updateUi(self):
        self.hpspinBox.setValue(self.temp[0])
        self.atkspinBox.setValue(self.temp[1])
        self.defspinBox.setValue(self.temp[2])
        self.spdspinBox.setValue(self.temp[3])
        self.spatkspinBox.setValue(self.temp[4])
        self.spdefspinBox.setValue(self.temp[5])
        self.type1.setCurrentIndex(self.temp[6])
        self.type2.setCurrentIndex(self.temp[7])
        self.catchRate.setValue(self.temp[8])
        self.baseExp.setValue(self.temp[9])
        self.hpEvs.setValue(self.temp[10])
        self.atkEvs.setValue(self.temp[11])
        self.defEvs.setValue(self.temp[12])
        self.spdEvs.setValue(self.temp[13])
        self.spatkEvs.setValue(self.temp[14])
        self.spdefEvs.setValue(self.temp[15])
        self.heldItem1.setCurrentIndex(self.temp[16])
        self.heldItem2.setCurrentIndex(self.temp[17])
        self.genderVal.setValue(self.temp[18])
        self.stepsMultiplier.setValue(self.temp[19])
        self.baseHappiness.setValue(self.temp[20])
        self.maxExp.setCurrentIndex(self.temp[21])
        self.eggGroup1.setCurrentIndex(self.temp[22])
        self.eggGroup2.setCurrentIndex(self.temp[23])
        self.ability1.setCurrentIndex(self.temp[24])
        self.ability2.setCurrentIndex(self.temp[25])
        self.runChance.setValue(self.temp[26])
        self.colorVal.setValue(self.temp[27])
        self.checkBoxHandle(self.tm1,self.temp[28]&1) 
        self.checkBoxHandle(self.tm2,(self.temp[28]>>1)&1)
        self.checkBoxHandle(self.tm3,(self.temp[28]>>2)&1)
        self.checkBoxHandle(self.tm4,(self.temp[28]>>3)&1)
        self.checkBoxHandle(self.tm5,(self.temp[28]>>4)&1)
        self.checkBoxHandle(self.tm6,(self.temp[28]>>5)&1)
        self.checkBoxHandle(self.tm7,(self.temp[28]>>6)&1)
        self.checkBoxHandle(self.tm8,(self.temp[28]>>7)&1)
        self.checkBoxHandle(self.tm9,self.temp[29]&1) 
        self.checkBoxHandle(self.tm10,(self.temp[29]>>1)&1)
        self.checkBoxHandle(self.tm11,(self.temp[29]>>2)&1)
        self.checkBoxHandle(self.tm12,(self.temp[29]>>3)&1)
        self.checkBoxHandle(self.tm13,(self.temp[29]>>4)&1)
        self.checkBoxHandle(self.tm14,(self.temp[29]>>5)&1)
        self.checkBoxHandle(self.tm15,(self.temp[29]>>6)&1)
        self.checkBoxHandle(self.tm16,(self.temp[29]>>7)&1)
        self.checkBoxHandle(self.tm17,self.temp[30]&1) 
        self.checkBoxHandle(self.tm18,(self.temp[30]>>1)&1)
        self.checkBoxHandle(self.tm19,(self.temp[30]>>2)&1)
        self.checkBoxHandle(self.tm20,(self.temp[30]>>3)&1)
        self.checkBoxHandle(self.tm21,(self.temp[30]>>4)&1)
        self.checkBoxHandle(self.tm22,(self.temp[30]>>5)&1)
        self.checkBoxHandle(self.tm23,(self.temp[30]>>6)&1)
        self.checkBoxHandle(self.tm24,(self.temp[30]>>7)&1)
        self.checkBoxHandle(self.tm25,self.temp[31]&1) 
        self.checkBoxHandle(self.tm26,(self.temp[31]>>1)&1)
        self.checkBoxHandle(self.tm27,(self.temp[31]>>2)&1)
        self.checkBoxHandle(self.tm28,(self.temp[31]>>3)&1)
        self.checkBoxHandle(self.tm29,(self.temp[31]>>4)&1)
        self.checkBoxHandle(self.tm30,(self.temp[31]>>5)&1)
        self.checkBoxHandle(self.tm31,(self.temp[31]>>6)&1)
        self.checkBoxHandle(self.tm32,(self.temp[31]>>7)&1)
        self.checkBoxHandle(self.tm33,self.temp[32]&1) 
        self.checkBoxHandle(self.tm34,(self.temp[32]>>1)&1)
        self.checkBoxHandle(self.tm35,(self.temp[32]>>2)&1)
        self.checkBoxHandle(self.tm36,(self.temp[32]>>3)&1)
        self.checkBoxHandle(self.tm37,(self.temp[32]>>4)&1)
        self.checkBoxHandle(self.tm38,(self.temp[32]>>5)&1)
        self.checkBoxHandle(self.tm39,(self.temp[32]>>6)&1)
        self.checkBoxHandle(self.tm40,(self.temp[32]>>7)&1)
        self.checkBoxHandle(self.tm41,self.temp[33]&1) 
        self.checkBoxHandle(self.tm42,(self.temp[33]>>1)&1)
        self.checkBoxHandle(self.tm43,(self.temp[33]>>2)&1)
        self.checkBoxHandle(self.tm44,(self.temp[33]>>3)&1)
        self.checkBoxHandle(self.tm45,(self.temp[33]>>4)&1)
        self.checkBoxHandle(self.tm46,(self.temp[33]>>5)&1)
        self.checkBoxHandle(self.tm47,(self.temp[33]>>6)&1)
        self.checkBoxHandle(self.tm48,(self.temp[33]>>7)&1)
        self.checkBoxHandle(self.tm49,self.temp[34]&1) 
        self.checkBoxHandle(self.tm50,(self.temp[34]>>1)&1)
        self.checkBoxHandle(self.tm51,(self.temp[34]>>2)&1)
        self.checkBoxHandle(self.tm52,(self.temp[34]>>3)&1)
        self.checkBoxHandle(self.tm53,(self.temp[34]>>4)&1)
        self.checkBoxHandle(self.tm54,(self.temp[34]>>5)&1)
        self.checkBoxHandle(self.tm55,(self.temp[34]>>6)&1)
        self.checkBoxHandle(self.tm56,(self.temp[34]>>7)&1)
        self.checkBoxHandle(self.tm57,self.temp[35]&1) 
        self.checkBoxHandle(self.tm58,(self.temp[35]>>1)&1)
        self.checkBoxHandle(self.tm59,(self.temp[35]>>2)&1)
        self.checkBoxHandle(self.tm60,(self.temp[35]>>3)&1)
        self.checkBoxHandle(self.tm61,(self.temp[35]>>4)&1)
        self.checkBoxHandle(self.tm62,(self.temp[35]>>5)&1)
        self.checkBoxHandle(self.tm63,(self.temp[35]>>6)&1)
        self.checkBoxHandle(self.tm64,(self.temp[35]>>7)&1)
        self.checkBoxHandle(self.tm65,self.temp[36]&1) 
        self.checkBoxHandle(self.tm66,(self.temp[36]>>1)&1)
        self.checkBoxHandle(self.tm67,(self.temp[36]>>2)&1)
        self.checkBoxHandle(self.tm68,(self.temp[36]>>3)&1)
        self.checkBoxHandle(self.tm69,(self.temp[36]>>4)&1)
        self.checkBoxHandle(self.tm70,(self.temp[36]>>5)&1)
        self.checkBoxHandle(self.tm71,(self.temp[36]>>6)&1)
        self.checkBoxHandle(self.tm72,(self.temp[36]>>7)&1)
        self.checkBoxHandle(self.tm73,self.temp[37]&1) 
        self.checkBoxHandle(self.tm74,(self.temp[37]>>1)&1)
        self.checkBoxHandle(self.tm75,(self.temp[37]>>2)&1)
        self.checkBoxHandle(self.tm76,(self.temp[37]>>3)&1)
        self.checkBoxHandle(self.tm77,(self.temp[37]>>4)&1)
        self.checkBoxHandle(self.tm78,(self.temp[37]>>5)&1)
        self.checkBoxHandle(self.tm79,(self.temp[37]>>6)&1)
        self.checkBoxHandle(self.tm80,(self.temp[37]>>7)&1)
        self.checkBoxHandle(self.tm81,self.temp[38]&1) 
        self.checkBoxHandle(self.tm82,(self.temp[38]>>1)&1)
        self.checkBoxHandle(self.tm83,(self.temp[38]>>2)&1)
        self.checkBoxHandle(self.tm84,(self.temp[38]>>3)&1)
        self.checkBoxHandle(self.tm85,(self.temp[38]>>4)&1)
        self.checkBoxHandle(self.tm86,(self.temp[38]>>5)&1)
        self.checkBoxHandle(self.tm87,(self.temp[38]>>6)&1)
        self.checkBoxHandle(self.tm88,(self.temp[38]>>7)&1)
        self.checkBoxHandle(self.tm89,self.temp[39]&1) 
        self.checkBoxHandle(self.tm90,(self.temp[39]>>1)&1)
        self.checkBoxHandle(self.tm91,(self.temp[39]>>2)&1)
        self.checkBoxHandle(self.tm92,(self.temp[39]>>3)&1)
        self.checkBoxHandle(self.hm1,(self.temp[39]>>4)&1) 
        self.checkBoxHandle(self.hm2,(self.temp[39]>>5)&1)
        self.checkBoxHandle(self.hm3,(self.temp[39]>>6)&1)
        self.checkBoxHandle(self.hm4,(self.temp[39]>>7)&1)
        self.checkBoxHandle(self.hm5,(self.temp[40])&1)
        self.checkBoxHandle(self.hm6,(self.temp[40]>>1)&1)
        self.checkBoxHandle(self.hm7,(self.temp[40]>>2)&1)
        self.checkBoxHandle(self.hm8,(self.temp[40]>>3)&1)
        self.moveLvl1.setValue(self.temp[41]>>9)
        self.moveLvl2.setValue(self.temp[42]>>9)
        self.moveLvl3.setValue(self.temp[43]>>9)
        self.moveLvl4.setValue(self.temp[44]>>9)
        self.moveLvl5.setValue(self.temp[45]>>9)
        self.moveLvl6.setValue(self.temp[46]>>9)
        self.moveLvl7.setValue(self.temp[47]>>9)
        self.moveLvl8.setValue(self.temp[48]>>9)
        self.moveLvl9.setValue(self.temp[49]>>9)
        self.moveLvl10.setValue(self.temp[50]>>9)
        self.moveLvl11.setValue(self.temp[51]>>9)
        self.moveLvl12.setValue(self.temp[52]>>9)
        self.moveLvl13.setValue(self.temp[53]>>9)
        self.moveLvl14.setValue(self.temp[54]>>9)
        self.moveLvl15.setValue(self.temp[55]>>9)
        self.moveLvl16.setValue(self.temp[56]>>9)
        self.moveLvl17.setValue(self.temp[57]>>9)
        self.moveLvl18.setValue(self.temp[58]>>9)
        self.moveLvl19.setValue(self.temp[59]>>9)
        self.moveLvl20.setValue(self.temp[60]>>9)
        self.move1.setCurrentIndex(self.temp[41]&0x1FF)
        self.move2.setCurrentIndex(self.temp[42]&0x1FF)
        self.move3.setCurrentIndex(self.temp[43]&0x1FF)
        self.move4.setCurrentIndex(self.temp[44]&0x1FF)
        self.move5.setCurrentIndex(self.temp[45]&0x1FF)
        self.move6.setCurrentIndex(self.temp[46]&0x1FF)
        self.move7.setCurrentIndex(self.temp[47]&0x1FF)
        self.move8.setCurrentIndex(self.temp[48]&0x1FF)
        self.move9.setCurrentIndex(self.temp[49]&0x1FF)
        self.move10.setCurrentIndex(self.temp[50]&0x1FF)
        self.move11.setCurrentIndex(self.temp[51]&0x1FF)
        self.move12.setCurrentIndex(self.temp[52]&0x1FF)
        self.move13.setCurrentIndex(self.temp[53]&0x1FF)
        self.move14.setCurrentIndex(self.temp[54]&0x1FF)
        self.move15.setCurrentIndex(self.temp[55]&0x1FF)
        self.move16.setCurrentIndex(self.temp[56]&0x1FF)
        self.move17.setCurrentIndex(self.temp[57]&0x1FF)
        self.move18.setCurrentIndex(self.temp[58]&0x1FF)
        self.move19.setCurrentIndex(self.temp[59]&0x1FF)
        self.move20.setCurrentIndex(self.temp[60]&0x1FF)
        self.evoAtk1.setEnabled(False)
        self.evoAtk2.setEnabled(False)
        self.evoAtk3.setEnabled(False)
        self.evoAtk4.setEnabled(False)
        self.evoAtk5.setEnabled(False)
        self.evoAtk6.setEnabled(False)
        self.evoAtk7.setEnabled(False)
        self.evoItem1.setEnabled(False)
        self.evoItem2.setEnabled(False)
        self.evoItem3.setEnabled(False)
        self.evoItem4.setEnabled(False)
        self.evoItem5.setEnabled(False)
        self.evoItem6.setEnabled(False)
        self.evoItem7.setEnabled(False)
        self.evoLvl1.setEnabled(False)
        self.evoLvl2.setEnabled(False)
        self.evoLvl3.setEnabled(False)
        self.evoLvl4.setEnabled(False)
        self.evoLvl5.setEnabled(False)
        self.evoLvl6.setEnabled(False)
        self.evoLvl7.setEnabled(False)
        self.evoReqPkm1.setEnabled(False)
        self.evoReqPkm2.setEnabled(False)
        self.evoReqPkm3.setEnabled(False)
        self.evoReqPkm4.setEnabled(False)
        self.evoReqPkm5.setEnabled(False)
        self.evoReqPkm6.setEnabled(False)
        self.evoReqPkm7.setEnabled(False)
    
        self.evoType1.setCurrentIndex(self.temp[61])
        if self.temp[61] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl1.setEnabled(True)
            self.evoLvl1.setValue(self.temp[62])
        elif self.temp[61] in (6,7,16,17,18,19):
            self.evoItem1.setEnabled(True)
            self.evoItem1.setCurrentIndex(self.temp[62])
        elif self.temp[61]==0x14:
            self.evoAtk1.setEnabled(True)
            self.evoAtk1.setCurrentIndex(self.temp[62])
        elif self.temp[61]==0x15:
            self.evoReqPkm1.setEnabled(True)
            self.evoReqPkm1.setCurrentIndex(self.temp[62])
        self.evoPkm1.setCurrentIndex(self.temp[63]) 
        self.evoType2.setCurrentIndex(self.temp[64])
        if self.temp[64] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl2.setEnabled(True)
            self.evoLvl2.setValue(self.temp[65])
        elif self.temp[64] in (6,7,16,17,18,19):
            self.evoItem2.setEnabled(True)
            self.evoItem2.setCurrentIndex(self.temp[65])
        elif self.temp[64]==0x14:
            self.evoAtk2.setEnabled(True)
            self.evoAtk2.setCurrentIndex(self.temp[65])
        elif self.temp[64]==0x15:
            self.evoReqPkm2.setEnabled(True)
            self.evoReqPkm2.setCurrentIndex(self.temp[65])
        self.evoPkm2.setCurrentIndex(self.temp[66])
        self.evoType3.setCurrentIndex(self.temp[67])
        if self.temp[67] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl3.setEnabled(True)
            self.evoLvl3.setValue(self.temp[68])
        elif self.temp[67] in (6,7,16,17,18,19):
            self.evoItem3.setEnabled(True)
            self.evoItem3.setCurrentIndex(self.temp[68])
        elif self.temp[67]==0x14:
            self.evoAtk3.setEnabled(True)
            self.evoAtk3.setCurrentIndex(self.temp[68])
        elif self.temp[67]==0x15:
            self.evoReqPkm3.setEnabled(True)
            self.evoReqPkm3.setCurrentIndex(self.temp[68])
        self.evoPkm3.setCurrentIndex(self.temp[69])
        self.evoType4.setCurrentIndex(self.temp[70])
        if self.temp[70] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl4.setEnabled(True)
            self.evoLvl4.setValue(self.temp[71])
        elif self.temp[70] in (6,7,16,17,18,19):
            self.evoItem4.setEnabled(True)
            self.evoItem4.setCurrentIndex(self.temp[71])
        elif self.temp[70]==0x14:
            self.evoAtk4.setEnabled(True)
            self.evoAtk4.setCurrentIndex(self.temp[71])
        elif self.temp[70]==0x15:
            self.evoReqPkm4.setEnabled(True)
            self.evoReqPkm4.setCurrentIndex(self.temp[71])
        self.evoPkm4.setCurrentIndex(self.temp[72])
        self.evoType5.setCurrentIndex(self.temp[73])
        if self.temp[73] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl5.setEnabled(True)
            self.evoLvl5.setValue(self.temp[74])
        elif self.temp[73] in (6,7,16,17,18,19):
            self.evoItem5.setEnabled(True)
            self.evoItem5.setCurrentIndex(self.temp[74])
        elif self.temp[73]==0x14:
            self.evoAtk5.setEnabled(True)
            self.evoAtk5.setCurrentIndex(self.temp[74])
        elif self.temp[73]==0x15:
            self.evoReqPkm5.setEnabled(True)
            self.evoReqPkm5.setCurrentIndex(self.temp[74])
        self.evoPkm5.setCurrentIndex(self.temp[75])
        self.evoType6.setCurrentIndex(self.temp[76])
        if self.temp[76] in (4,8,9,10.11,12,13,14,21,22):
            self.evoLvl6.setEnabled(True)
            self.evoLvl6.setValue(self.temp[77])
        elif self.temp[76] in (6,7,16,17,18,19):
            self.evoItem6.setEnabled(True)
            self.evoItem6.setCurrentIndex(self.temp[77])
        elif self.temp[76]==0x14:
            self.evoAtk6.setEnabled(True)
            self.evoAtk6.setCurrentIndex(self.temp[77])
        elif self.temp[76]==0x15:
            self.evoReqPkm6.setEnabled(True)
            self.evoReqPkm6.setCurrentIndex(self.temp[77])
        self.evoPkm6.setCurrentIndex(self.temp[78])
        self.evoType7.setCurrentIndex(self.temp[79])
        if self.temp[79] in (4,8,9,10,11,12,13,14,21,22):
            self.evoLvl7.setEnabled(True)
            self.evoLvl7.setValue(self.temp[80])
        elif self.temp[79] in (6,7,16,17,18,19):
            self.evoItem7.setEnabled(True)
            self.evoItem7.setCurrentIndex(self.temp[80])
        elif self.temp[79]==0x14:
            self.evoAtk7.setEnabled(True)
            self.evoAtk7.setCurrentIndex(self.temp[80])
        elif self.temp[79]==0x15:
            self.evoReqPkm7.setEnabled(True)
            self.evoReqPkm7.setCurrentIndex(self.temp[80])
        self.evoPkm7.setCurrentIndex(self.temp[81])
    def checkBoxHandle(self,checkbox, bit):
        if bit == 0:
            checkbox.setCheckState(Qt.Unchecked)
        else:
            checkbox.setCheckState(Qt.Checked)
    def updatehp(self,event):
        self.temp[0]=self.hpspinBox.value
    def updateatk(self,event):
        self.temp[0]=self.hpspinBox.value
    def updatedef(self,event):
        self.temp[0]=self.hpspinBox.value
    def updatespd(self,event):
        self.temp[0]=self.hpspinBox.value
    def updatespatk(self,event):
        self.temp[0]=self.hpspinBox.value
    def updatespdef(self,event):
        self.temp[0]=self.hpspinBox.value
    def extractToSql(self):
        """print "Success ",
        db=QSqlDatabase.addDatabase("QMYSQL")
        db.setHostName("dbs.projectpokemon.org")
        db.setDatabaseName("pporg_dex")
        db.setUserName("pporgadmin")
        db.setPassword("HackingRulez!@#")
        if not db.open():
            QMessageBox.warning(None,"Phone Log", QString("Database Error: %1").arg(db.lastError().text()))
        else:
            print "Success Again"
        query=QSqlQuery()
        query.exec_("CREATE TABLE poke (natid INTEGER PRIMARY KEY UNIQUE NOT NULL,name VARCHAR(10) NOT NULL UTF)")
        print db.lastError().text()"""
    
        sf=QFile("dpdexkr.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        temptext=poketext.PokeTextData(self.archive.gmif.files[604])
        temptext.decrypt()
        ts<<"SET SQL_MODE=\"NO_AUTO_VALUE_ON_ZERO\";\n"
        ts<<"DROP TABLE IF EXISTS `dppokekr`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `dppokekr` (\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `name` VARCHAR(20),\n"
        ts<<"  `height` VARCHAR(20),\n"
        ts<<"  `weight` VARCHAR(20),\n"
        ts<<"  `desc` TEXT,\n"
        ts<<"  `dflavortext` TEXT,\n"
        ts<<"  `numforms` TINYINT,\n"
        ts<<"  `pflavortext` TEXT,\n"
        ts<<"  `stats` TINYINT,\n"
        ts<<"  PRIMARY KEY  (`natid`)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `dppokeeskr` (`natid`,`name`,`height`,`weight`,`desc`,`dflavortext`,`numforms`, `pflavortext`,`stats`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            ts<<"("<<i<<", '"<<unicode(self.pokeName.text()).title()<<"', '"<<self.height.text()<<"', '"<<self.weight.text()<<"', '"<<self.description.text()<<"', '"<<self.flavorText.toPlainText().replace("\\n"," ").replace("\\x0001", " ")<<"',"
            if i== 201:
                ts<<28<<","
            elif i== 412:
                ts<<3<<","
            elif i== 422 or i==423:
                ts<<2<<","
            else:
                ts<<self.chooseForm.count()<<","
            ts<<"'"+temptext.strlist[i].replace("\\n"," ").replace("\\x0001", " ")+"',"
            if i in (201, 412, 422, 423):
                ts<<1
            else:
                ts<<0    
            if i%50 == 0:
                print i
            if i==493:
                ts<<");"
            else:
                ts<<"),\n"
        sf.close() 
        """sf=QFile("pldatadex.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        #arm9filename=mw.rom.getFolder()+"/overlay/overlay_0005.bin"
        #mfh=QFile(arm9filename)
        #mfh.open(QIODevice.ReadOnly)
        #mds=QDataStream(mfh)
        #mds.setByteOrder(QDataStream.LittleEndian
        ts<<"DROP TABLE IF EXISTS `datapl`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `datapl` (\n"
        ts<<"  `dataid` SMALLINT UNSIGNED,\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `basehp` SMALLINT UNSIGNED,\n"
        ts<<"  `baseatk` SMALLINT UNSIGNED,\n"
        ts<<"  `basedef` SMALLINT UNSIGNED,\n"
        ts<<"  `basespd` SMALLINT UNSIGNED,\n"
        ts<<"  `basespatk` SMALLINT UNSIGNED,\n"
        ts<<"  `basespdef` SMALLINT UNSIGNED,\n"
        ts<<"  `type1` TINYINT,\n"
        ts<<"  `type2` TINYINT,\n"
        ts<<"  `item1` SMALLINT,\n"
        ts<<"  `item2` SMALLINT,\n"
        ts<<"  `ability1` SMALLINT,\n"
        ts<<"  `ability2` SMALLINT,\n"
        ts<<"  `steps` SMALLINT UNSIGNED,\n"
        ts<<"  `basehappiness` TINYINT UNSIGNED,\n"
        ts<<"  `runchance` TINYINT UNSIGNED,\n"
        ts<<"  `genderval` TINYINT UNSIGNED,\n"
        ts<<"  `maxexp` VARCHAR(20),\n"
        ts<<"  `baseexp` SMALLINT,\n"
        ts<<"  `egggroup1` TINYINT,\n"
        ts<<"  `egggroup2` TINYINT,\n"
        ts<<"  `catchrate` SMALLINT,\n"
        ts<<"  `hpev` TINYINT,\n"
        ts<<"  `atkev` TINYINT,\n"
        ts<<"  `defev` TINYINT,\n"
        ts<<"  `spdev` TINYINT,\n"
        ts<<"  `spatkev` TINYINT,\n"
        ts<<"  `spdefev` TINYINT,\n"
        ts<<"  `color` SMALLINT,\n"
        ts<<"  PRIMARY KEY  (`dataid`)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
        
        #Begin Inserting Data
        ts<<"INSERT INTO `datapl` (`dataid`,`natid`,`basehp`,`baseatk`,`basedef`,`basespd`,`basespatk`,`basespdef`,`type1`,`type2`,`item1`,`item2`,`ability1`,`ability2`,`steps`,`basehappiness`,`runchance`,`genderval`,`maxexp`,`baseexp`,`egggroup1`, `egggroup2`,`catchrate`,`hpev`,`atkev`,`defev`,`spdev`,`spatkev`,`spdefev`,`color`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                ts<<"("<<self.dataids[j]<<","<<i<<","<<self.hpspinBox.value()
                ts<<","<<self.atkspinBox.value()<<","<<self.defspinBox.value()
                ts<<","<<self.spdspinBox.value()<<","<<self.spatkspinBox.value()
                ts<<","<<self.spdefspinBox.value()<<","
                ts<<self.type1.currentIndex()<<", "<<self.type2.currentIndex()<<", "
                ts<<self.heldItem1.currentIndex()<<", "<<self.heldItem2.currentIndex()<<","
                ts<<self.ability1.currentIndex()<<","<<self.ability2.currentIndex()<<","
                ts<<self.stepsMultiplier.value()*256<<","<<self.baseHappiness.value()<<","
                ts<<self.runChance.value()<<","<<self.genderVal.value()<<","
                ts<<"'"<<self.maxExp.currentText()<<"'"<<","<<self.baseExp.value()<<","
                ts<<self.eggGroup1.currentIndex()
                ts<<","<<self.eggGroup2.currentIndex()
                ts<<","<<self.catchRate.value()
                ts<<","<<self.hpEvs.value()<<","<<self.atkEvs.value()<<","<<self.defEvs.value()<<","<<self.spdEvs.value()<<","<<self.spatkEvs.value()<<","<<self.spdefEvs.value()
                ts<<","<<self.colorVal.value()
                if i%50 == 0:
                    print i
                if i==493:
                    ts<<");"
                else:
                    ts<<"),\n"
        sf.close()"""
        """sf=QFile("pllvlmoves.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `lvlmvpl`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `lvlmvpl` (\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `form` TINYINT,\n"
        ts<<"  `lvl` TINYINT,\n"
        ts<<"  `moveid` SMALLINT\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `lvlmvpl` (`natid`,`form`, `lvl`, `moveid`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                for k in range(0,self.nummoves):
                    ts<<"("<<i<<","<<j<<","<<self.movelvllist[k].value()<<","<<self.movelist[k].currentIndex()<<"),\n"
                if i%50 == 0:
                    print i
                if i==493:
                    print "done"
        sf.close()"""
        sf=QFile("dpformskr.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `formnamesdpkr`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `formnamesdpkr` (\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `form` TINYINT,\n"
        ts<<"  `name` VARCHAR(30)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `formnamesdpkr` (`natid`,`form`, `name`) VALUES\n"
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[685])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[614])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[600])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[602])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[614])
        binary.decrypt()
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                if i not in (201, 412, 422, 423):
                    ts<<"("<<i<<","<<j<<",'"<<self.chooseForm.currentText()<<"'),\n"
                else:
                    if i in (422,  423):
                        ts<<"("<<i<<","<<0<<",'"<<binary.strlist[15]<<"'),\n"
                        ts<<"("<<i<<","<<1<<",'"<<binary.strlist[16]<<"'),\n"
                    elif i == 412:
                        ts<<"("<<i<<","<<0<<",'"<<binary.strlist[17]<<"'),\n"
                        ts<<"("<<i<<","<<1<<",'"<<binary.strlist[18]<<"'),\n"
                        ts<<"("<<i<<","<<2<<",'"<<binary.strlist[19]<<"'),\n"
                    else:
                        for k in range(0, 26):
                            ts<<"("<<i<<","<<k<<",'"<<self.choosePokemon.currentText()+" "+chr(65+k)<<"'),\n"
                        ts<<"("<<i<<","<<26<<",'"<<self.choosePokemon.currentText()+" !"<<"'),\n"
                        ts<<"("<<i<<","<<27<<",'"<<self.choosePokemon.currentText()+" ?"<<"'),\n"
                if i%50 == 0:
                    print i
                if i==493:
                    print "done"
        sf.close()
        """sf=QFile("pltms.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `tmspl`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `tmspl` (\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `form` TINYINT,\n"
        ts<<"  `tm` TINYINT\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `tmspl` (`natid`,`form`, `tm`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                tempbool=False
                for k in range(0,92):
                    if self.tmlist[k].isChecked():
                        ts<<"("<<i<<","<<j<<","<<k+1<<"),\n"
                if i%50 == 0:
                    print i
                if i==493:
                    print "done"
        sf.close()
        #hm table
        sf=QFile("plhms.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `hmspl`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS hmspl` (\n"
        ts<<"  `natid` SMALLINT UNSIGNED,\n"
        ts<<"  `form` TINYINT,\n"
        ts<<"  `hm` TINYINT,\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `hmspl` (`natid`,`form`, `hm`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                for k in range(0,8):
                    if self.hmlist[k].isChecked():
                        ts<<"("<<i<<","<<j<<","<<k+1<<"),\n"
                if i%50 == 0:
                    print i
                if i==493:
                    print "done"
        sf.close()"""
        #Begin Platinum Tutor Moves
        """tutorMoves=(0x123, 0xBD, 0xD2, 0xC4, 0xCD, 0x09, 0x07, 0x114, 0x8, 0x1BA, 0x191, 0x1D2, 0x17C, 0xAD, 0xB4, 0x13A, 0x10E, 0x11B, 0xC8, 0xF6, 0xEB, 0x144, 0x1AC, 0x19A, 0x19E, 0x1B9, 0xEF, 0x192, 0x14E, 0x189, 0x183, 0x154, 0x10F, 0x101, 0x11A, 0x185, 0x81, 0xFD)
        sf=QFile("pltutmvs.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        arm9filename=mw.rom.getFolder()+"/overlay/overlay_0005.bin"
        mfh=QFile(arm9filename)
        mfh.open(QIODevice.ReadOnly)
        mds=QDataStream(mfh)
        mds.setByteOrder(QDataStream.LittleEndian)
        ts<<"DROP TABLE IF EXISTS `tutormvspl`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `tutormvspl` (\n"
        ts<<"  `dataid` SMALLINT UNSIGNED,\n"
        ts<<"  `form` SMALLINT UNSIGNED,\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
    
        #Begin Inserting
        ts<<"INSERT INTO `tutormvspl` (`natid`,`form`, `hm`) VALUES\n"
        for i in range (1,494):
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                tutorMvs=[]
                num=self.getOffset(i,j)
                mfh.seek(num+0x3012C)
                tempnum=mds.readUInt32()
                tempnum2=mds.readUInt16()
                for l in range (0,32):
                    if (tempnum>>l)&1==1:
                        tutorMvs.append(tutorMoves[l])
                for l in range (0,6):
                    if (tempnum2>>l)&1==1:
                        tutorMvs.append(tutorMoves[32+l])
                for k in range(0,len(tutorMvs)):
                    ts<<"("<<i<<","<<j<<","<<tutorMvs[k]<<"),\n"
        mfh.close()
        sf.close()"""
        """sf=QFile("evodex.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `data`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `evo` (\n"
        ts<<"  `dataid` SMALLINT,\n"
        ts<<"  `evotype` SMALLINT,\n"
        ts<<"  `evotext` TEXT,\n"
        ts<<"  `evoparam` SMALLINT,\n"
        ts<<"  `evopkm` SMALLINT,\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
        
        #Begin Inserting Data
        ts<<"INSERT INTO `evo` (`evotype`,`evotext`,`evoparam`,`evopkm`) VALUES\n"
        for i in range (1,494):\
            self.choosePokemon.setCurrentIndex(i)
            for j in range(0,len(self.dataids)):
                self.chooseForm.setCurrentIndex(j)
                for k in range(0,7):
                    if self.evotypes[k].currentIndex()!=0:
                        ts<<"("<<self.dataids[j]<<","
                        ts<<self.evotypes[k].currentIndex()<<",'"
                        ts<<self.evotypes[k].currentText()<<"',"
                        ts<<self.evoparams[k]<<","
                        ts<<self.evopkms[k].currentIndex()<<"),\n"
                if i%50 == 0:
                    print i
            
        sf.close()
        """
    def getOffset(self, natid,form):
        r0=form
        r4=natid
        r2=natid
        
        r1=0x1DF
        if r4 > r1:
            r3=r1
            r3+=8
            if r4>r3:
                r3=r1
                r3+=0xD
                if r4==r3:
                    if r0==1:
                        r2=r1
                        r2+=0x15
            else:
                r3=r1
                r3+=8
                if r4==r3:
                    if r0==1:
                        r2=r1
                        r2+=0x14
        elif r4==r1:
            if r0==1:
                r2=r1
                r2+=0x16
            elif r0==2:
                r2=r1
                r2+=0x17
            elif r0==3:
                r2=r1
                r2+=0x18
            elif r0==4:
                r2=r1
                r2+=0x19
            elif r0==5:
                r2=r1
                r2+=0x1A
        else:
            r3=r1+0
            r3-=0x5D
            if r4>r3:
                r3=r1
                r3-=0x42
                if r4==r3:
                    if r0==1:
                        r2=r1
                        r2+=0x12
                    elif r0==2:
                        r2=r1
                    r2+=0x13
            else:
                r3=r1
                r3-=0x5D
                if r3==r4:
                    if r0==1:
                        r2=r1
                        r2+=0xF
                    elif r0==2:
                        r2=r1
                        r2+=0x10
                    elif r0==3:
                        r2=r1
                        r2+=0x11
        r1=r2-1
        r0=r1<<2
        r1=r1+r0
        return r1
class MapDlg(QDialog, ui_ppremapedit.Ui_mapDlg):
    def __init__(self,parent=None):
        super(MapDlg,self).__init__(parent)
        self.setupUi(self)
        self.scriptNarc=ReadScriptNarc()
        self.msgNarc=ReadMsgNarc()
        mapnamefilename=mw.rom.getFolder()+"/root/fielddata/maptable/mapname.bin"
        fh=QFile(mapnamefilename)
        fh.open(QIODevice.ReadOnly)
        size=fh.size()
        fh.close()
        size/=0x10
        for i in range(0,size):
            self.chooseMap.addItem(unicode(i))
    def updateMapData(self,n):
        num=self.chooseMap.currentIndex()
        num=mw.Of[0]+num*0x18
        arm9filename=mw.rom.getFolder()+"/arm9.bin"
        fh=QFile(arm9filename)
        fh.open(QIODevice.ReadOnly)
        ds=QDataStream(fh)
        ds.setByteOrder(QDataStream.LittleEndian)
        fh.seek(num)
        self.spinBox.setValue(ds.readUInt16())
        self.spinBox_2.setValue(ds.readUInt16())
        self.spinBox_3.setValue(ds.readUInt16())
        self.spinBox_4.setValue(ds.readUInt16())
        self.spinBox_5.setValue(ds.readUInt16())
        self.spinBox_6.setValue(ds.readUInt16())
        self.spinBox_7.setValue(ds.readUInt16())
        self.spinBox_8.setValue(ds.readUInt16())
        self.spinBox_9.setValue(ds.readUInt16())
        self.spinBox_10.setValue(ds.readUInt16())
        self.spinBox_11.setValue(ds.readUInt16())
        self.spinBox_12.setValue(ds.readUInt16())
        fh.close()
        self.scr=scripts.scriptFile(self.scriptNarc.gmif.files[self.spinBox_3.value()], mw.ID)
        self.scriptEdit.setPlainText(self.scr.getScript())
        self.orderEdit.setPlainText(self.scr.getOrders())
        self.textFile=poketext.PokeTextData(self.msgNarc.gmif.files[self.spinBox_5.value()])
        self.textFile.decrypt()
        self.text=""
        for i in range(0, len(self.textFile.strlist)):
            self.text+="text_"+str(i)+"=\""+self.textFile.strlist[i]+"\"\n"
        self.textEdit.setPlainText(self.text)
    def updateMap(self):
        result=self.scr.getBinary(self.scriptEdit.toPlainText(),self.orderEdit.toPlainText())
        self.scriptNarc.replaceFile(self.spinBox_3.value(), result)
        WriteScriptNarc(self.scriptNarc)
        if result==False:
            print "Error",  self.scr.errorText
        else:
            print result
class TmHmDlg(QDialog, ui_ppretmhmedit.Ui_TmHmEditDlg):
	def __init__(self,parent=None):
		super(TmHmDlg,self).__init__(parent)
		self.setupUi(self)
		self.archive=ReadMsgNarc()
		binary=poketext.PokeTextData(self.archive.gmif.files[392])
		binary.decrypt()
		self.chooseTm.addItems(binary.strlist[0x148:0x1AC])
		binary=poketext.PokeTextData(self.archive.gmif.files[647])
		binary.decrypt()
		self.chooseMove.addItems(binary.strlist)
		self.chooseTm.setCurrentIndex(1)
		self.chooseTm.setCurrentIndex(0)
		#self.extractToSql()
	def changedTm(self,event):
		num=self.chooseTm.currentIndex()
		num=0xF0BFC+num*0x2
		arm9filename=mw.rom.getFolder()+"/arm9.bin"
		fh=QFile(arm9filename)
		fh.open(QIODevice.ReadOnly)
		ds=QDataStream(fh)
		ds.setByteOrder(QDataStream.LittleEndian)
		fh.seek(num)
		movenum=ds.readUInt16()
		fh.close()
		self.chooseMove.setCurrentIndex(movenum)
	def extractToSql(self):
		sf=QFile("tmdex.sql")
		sf.open(QIODevice.WriteOnly)
		ts=QTextStream(sf)
		ts.setCodec("UTF-8")
		ts<<"DROP TABLE IF EXISTS `tms`;\n"
		ts<<"CREATE TABLE IF NOT EXISTS `tms` (\n"
		ts<<"  `tmnum` TINYINT,"
		ts<<"  `movenum` SMALLINT,"
		ts<<"  PRIMARY KEY  (`tmnum`)\n"
		ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
		
		#Begin Inserting Data
		ts<<"INSERT INTO `tms` (`tmnum`,`movenum`) VALUES\n"
		for i in range (0,100):
			self.chooseTm.setCurrentIndex(i)
			ts<<"("<<i<<","<<self.chooseMove.currentIndex()<<")"
			if i==99:
				ts<<";"
				print "done"
			else:
				ts<<",\n"
class MoveDlg(QDialog, ui_ppremoveedit.Ui_MoveEditDlg):
    def __init__(self,parent=None):
        super(MoveDlg,self).__init__(parent)
        self.setupUi(self)
        self.waza=ReadWazaNarc()
        self.archive=ReadMsgNarc()
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[636])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[647])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[575])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[577])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[588])
        binary.decrypt()
        self.chooseMove.addItems(binary.strlist)
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[207])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[208])
        else:
            if mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[194])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[195])
        binary.decrypt()
        self.ctype.addItems(binary.strlist[2:7])
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[616])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[624])
        else:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[557])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[565])
        binary.decrypt()
        self.type.addItems(binary.strlist)
        for i in range (0,0x120):
            self.effect.addItem(unicode(i))
        self.cpower=(0,2,2,8,2,3,1,2,0,0,2,0,0,2,2,2,0,2,2,2,1,0,2,1)
        #self.extractToSql()
    def moveChanged(self):
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                temptext=poketext.PokeTextData(self.archive.gmif.files[635])
            else:
                temptext=poketext.PokeTextData(self.archive.gmif.files[646])
        else:
            if mw.lang==0x4A:
                temptext=poketext.PokeTextData(self.archive.gmif.files[574])
            elif mw.lang==0x4B:
                temptext=poketext.PokeTextData(self.archive.gmif.files[576])
            else:
                temptext=poketext.PokeTextData(self.archive.gmif.files[587])
        temptext.decrypt()
        self.atkDesc.setPlainText(temptext.strlist[self.chooseMove.currentIndex()])
        file=self.waza.gmif.files[self.chooseMove.currentIndex()]
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                temptext=poketext.PokeTextData(self.archive.gmif.files[209])
            else:
                temptext=poketext.PokeTextData(self.archive.gmif.files[210])
        else:
            if mw.lang==0x4A:
                temptext=poketext.PokeTextData(self.archive.gmif.files[0])
            if mw.lang==0x4B:
                temptext=poketext.PokeTextData(self.archive.gmif.files[196])
            else:
                temptext=poketext.PokeTextData(self.archive.gmif.files[197])
        temptext.decrypt()
        self.catkDesc.setPlainText(temptext.strlist[45+ord(file[12])])
        self.cindex=ord(file[12])
        self.effect.setCurrentIndex(ord(file[0])|(ord(file[1])<<8))
        self.category.setCurrentIndex(ord(file[2]))
        self.basePower.setValue(ord(file[3]))
        self.accuracy.setValue(ord(file[5]))
        self.type.setCurrentIndex(ord(file[4]))
        self.ctype.setCurrentIndex(ord(file[13]))
        self.pp.setValue(ord(file[6]))
        self.effectChance.setValue(ord(file[7]))
        self.priority.setValue(ord(file[10]))
        num=0
        for i in range(0,8):
            if (ord(file[8])>>i)==1:
                num=i+1
        self.target.setCurrentIndex(num)
        self.unk1.setValue(ord(file[11]))
    def extractToSql(self):
        sf=QFile("movedexdpkr.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `moveskr`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `moveskr` (\n"
        ts<<"  `moveid` SMALLINT,\n"
        ts<<"  `name` VARCHAR(20),\n"
        ts<<"  `power` SMALLINT,\n"
        ts<<"  `pp` TINYINT,\n"
        ts<<"  `type` TINYINT,\n"
        ts<<"  `acc` SMALLINT,\n"
        ts<<"  `target` TINYINT,\n"
        ts<<"  `effectchance` SMALLINT,\n"
        ts<<"  `category` TINYINT,\n"
        ts<<"  `ctype` TINYINT,\n"
        ts<<"  `cpoints` TINYINT,\n"
        ts<<"  `desc` TEXT,\n"
        ts<<"  `cdesc` TEXT,\n"
        ts<<"  `effect` SMALLINT,\n"
        ts<<"  PRIMARY KEY  (`moveid`)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
        
        #Begin Inserting Data
        ts<<"INSERT INTO `moveskr` (`moveid`,`name`,`power`,`pp`,`type`,`acc`,`target`,`effectchance`,`category`,`ctype`,`cpoints`,`desc`,`cdesc`,`effect`) VALUES\n"
        for i in range (1,468):
            self.chooseMove.setCurrentIndex(i)
            ts<<"("<<i<<",'"<<self.chooseMove.currentText()<<"',"
            ts<<self.basePower.value()<<","<<self.pp.value()<<","
            ts<<self.type.currentIndex()<<","<<self.accuracy.value()<<","
            ts<<"'"<<self.target.currentIndex()<<"',"<<self.effectChance.value()<<","
            ts<<self.category.currentIndex()<<","<<self.ctype.currentIndex()<<","
            ts<<self.cpower[self.cindex]<<",'"<<self.atkDesc.toPlainText().replace("\\n"," ").replace("\\x0001", " ")<<"','"
            ts<<self.catkDesc.toPlainText().replace("\\n"," ").replace("\\x0001", " ")<<"',"
            ts<<self.effect.currentIndex()<<")"
            if i==467:
                ts<<";"
                print "done"
            else:
                ts<<",\n"
class ItemDlg(QDialog, ui_ppreitemedit.Ui_ItemEditDlg):
    def __init__(self,parent=None):
        super(ItemDlg,self).__init__(parent)
        self.setupUi(self)
        self.archive=ReadMsgNarc()
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[390])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[392])
        else: 
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[340])
            elif mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[342])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[344])
        binary.decrypt()
        self.chooseItem.addItems(binary.strlist)
        #self.extractToSql()
    def extractToSql(self):
        sf=QFile("itemdexkr.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `itemskr`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `itemskr` (\n"
        ts<<"  `itemid` SMALLINT,"
        ts<<"  `name` VARCHAR(30),"
        ts<<"  PRIMARY KEY  (`itemid`)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
        
        #Begin Inserting Data
        ts<<"INSERT INTO `itemskr` (`itemid`,`name`) VALUES\n"
        for i in range (0,465):
            self.chooseItem.setCurrentIndex(i)
            ts<<"("<<i<<",'"<<self.chooseItem.currentText()<<"')"
            if i==464:
                ts<<";"
                print "done"
            else:
                ts<<",\n"
class AbilityDlg(QDialog, ui_ppreabilityedit.Ui_AbilityEditDlg):
    def __init__(self,parent=None):
        super(AbilityDlg,self).__init__(parent)
        self.setupUi(self)
        self.archive=ReadMsgNarc()
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[604])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[610])
        else:
            if mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[546])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[552])
        binary.decrypt()
        self.chooseAbility.addItems(binary.strlist)
        #self.extractToSql()
    def extractToSql(self):
        if mw.ID==0x4C50:
            if mw.lang==0x4A:
                binary=poketext.PokeTextData(self.archive.gmif.files[605])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[612])
        else:
            if mw.lang==0x4B:
                binary=poketext.PokeTextData(self.archive.gmif.files[547])
            else:
                binary=poketext.PokeTextData(self.archive.gmif.files[554])
        binary.decrypt()
        sf=QFile("abilitydexkr.sql")
        sf.open(QIODevice.WriteOnly)
        ts=QTextStream(sf)
        ts.setCodec("UTF-8")
        ts<<"DROP TABLE IF EXISTS `abilitieskr`;\n"
        ts<<"CREATE TABLE IF NOT EXISTS `abilitieskr` (\n"
        ts<<"  `id` SMALLINT,\n"
        ts<<"  `name` VARCHAR(30),\n"
        ts<<"  `desc` TEXT,\n"
        ts<<"  PRIMARY KEY  (`id`)\n"
        ts<<") ENGINE=MyISAM  DEFAULT CHARSET=utf8;\n\n"
        
        #Begin Inserting Data
        ts<<"INSERT INTO `abilitieskr` (`id`,`name`,`desc`) VALUES\n"
        for i in range (0,124):
            self.chooseAbility.setCurrentIndex(i)
            ts<<"("<<i<<",'"<<self.chooseAbility.currentText()<<"','"<<binary.strlist[i].replace("\\n"," ").replace("\\x0001", " ")<<"')"
            if i==123:
                ts<<";"
                print "done"
            else:
                ts<<",\n"
class ScriptDlg(QDialog, ui_pprescripts.Ui_scriptDlg):
    def __init__(self,parent=None):
        super(ScriptDlg,self).__init__(parent)
        self.setupUi(self)
        self.scriptNarc=ReadScriptNarc()
        size=self.scriptNarc.btaf.getEntryNum()
        for i in range(0,size):
            self.chooseScript.addItem(unicode(i))
    def updateScript(self,n):
        num=self.chooseScript.currentIndex()
        if num < mw.Of[1] or num > mw.Of[2]:
            self.scr=scripts.scriptFile(self.scriptNarc.gmif.files[num])
            self.scriptEdit.setPlainText(self.scr.getScript())
            self.orderEdit.setPlainText(self.scr.getOrders())
        else:
            self.scriptEdit.setPlainText("Cannot Edit This File")
app = QApplication(sys.argv)
mw = MainWindow()
mw.show()
app.exec_()
#else:
#	QMessageBox.warning(None,"Phone Log", QString("Database Error: %1").arg(db.lastError().text()))

